(function (_, kotlin_kotlin) {
  'use strict';
  //region block: imports
  var imul = Math.imul;
  var log2 = Math.log2;
  var protoOf = kotlin_kotlin.$_$.y8;
  var interfaceMeta = kotlin_kotlin.$_$.d8;
  var setMetadataFor = kotlin_kotlin.$_$.z8;
  var toString = kotlin_kotlin.$_$.b9;
  var IllegalArgumentException_init_$Create$ = kotlin_kotlin.$_$.f1;
  var classMeta = kotlin_kotlin.$_$.u7;
  var getStringHashCode = kotlin_kotlin.$_$.b8;
  var THROW_CCE = kotlin_kotlin.$_$.jc;
  var objectMeta = kotlin_kotlin.$_$.x8;
  var ArrayList_init_$Create$ = kotlin_kotlin.$_$.m;
  var charSequenceLength = kotlin_kotlin.$_$.s7;
  var charSequenceGet = kotlin_kotlin.$_$.r7;
  var toString_0 = kotlin_kotlin.$_$.w1;
  var Unit_instance = kotlin_kotlin.$_$.l3;
  var _Char___init__impl__6a9atx = kotlin_kotlin.$_$.s1;
  var arrayConcat = kotlin_kotlin.$_$.a;
  var listOf = kotlin_kotlin.$_$.t5;
  var withSign = kotlin_kotlin.$_$.d9;
  var VOID = kotlin_kotlin.$_$.g;
  var coerceAtLeast = kotlin_kotlin.$_$.f9;
  var getNumberHashCode = kotlin_kotlin.$_$.z7;
  var equals = kotlin_kotlin.$_$.w7;
  var numberToDouble = kotlin_kotlin.$_$.t8;
  var hashCode = kotlin_kotlin.$_$.c8;
  var roundToInt = kotlin_kotlin.$_$.c9;
  var DoubleCompanionObject_instance = kotlin_kotlin.$_$.x2;
  var coerceIn = kotlin_kotlin.$_$.j9;
  var Char = kotlin_kotlin.$_$.xb;
  var toInt = kotlin_kotlin.$_$.qb;
  var numberRangeToNumber = kotlin_kotlin.$_$.r8;
  var slice = kotlin_kotlin.$_$.fb;
  var startsWith = kotlin_kotlin.$_$.ib;
  var isInterface = kotlin_kotlin.$_$.m8;
  var contentEquals = kotlin_kotlin.$_$.l4;
  var coerceAtLeast_0 = kotlin_kotlin.$_$.h9;
  var objectCreate = kotlin_kotlin.$_$.w8;
  //endregion
  //region block: pre-declaration
  function toXYZ() {
    return this.l1c().m1c();
  }
  setMetadataFor(Color, 'Color', interfaceMeta);
  setMetadataFor(ColorComponentInfo, 'ColorComponentInfo', classMeta);
  setMetadataFor(WhitePoint, 'WhitePoint', classMeta);
  setMetadataFor(Illuminant, 'Illuminant', objectMeta);
  setMetadataFor(Companion, 'Companion', objectMeta);
  setMetadataFor(Ansi16, 'Ansi16', classMeta, VOID, [Color]);
  setMetadataFor(Companion_0, 'Companion', objectMeta);
  setMetadataFor(Ansi256, 'Ansi256', classMeta, VOID, [Color]);
  setMetadataFor(Companion_1, 'Companion', objectMeta);
  setMetadataFor(HSV, 'HSV', classMeta, VOID, [Color]);
  setMetadataFor(ICtCp, 'ICtCp', classMeta, VOID, [Color]);
  setMetadataFor(PqNonlinearity, 'PqNonlinearity', objectMeta);
  setMetadataFor(GammaTransferFunctions, 'GammaTransferFunctions', classMeta);
  setMetadataFor(LinearTransferFunctions, 'LinearTransferFunctions', objectMeta);
  function invoke$default(r, g, b, alpha, $super) {
    alpha = alpha === VOID ? 1.0 : alpha;
    return $super === VOID ? this.v1d(r, g, b, alpha) : $super.v1d.call(this, r, g, b, alpha);
  }
  function invoke(r, g, b, alpha) {
    return this.v1d(numberToDouble(r), numberToDouble(g), numberToDouble(b), numberToDouble(alpha));
  }
  function invoke$default_0(r, g, b, alpha, $super) {
    alpha = alpha === VOID ? 1.0 : alpha;
    return $super === VOID ? this.a1f(r, g, b, alpha) : invoke(r, g, b, alpha);
  }
  function from255(r, g, b, alpha) {
    return this.v1d(r / 255.0, g / 255.0, b / 255.0, alpha / 255.0);
  }
  function from255$default(r, g, b, alpha, $super) {
    alpha = alpha === VOID ? 255 : alpha;
    return $super === VOID ? this.b1f(r, g, b, alpha) : from255(r, g, b, alpha);
  }
  function invoke_0(hex) {
    var tmp = parseHex(validateHex(hex), 0);
    var tmp_0 = parseHex(hex, 1);
    var tmp_1 = parseHex(hex, 2);
    var tmp_2;
    // Inline function 'kotlin.let' call
    // Inline function 'kotlin.contracts.contract' call
    // Inline function 'com.github.ajalt.colormath.model.RGBColorSpace.invoke.<anonymous>' call
    var it = get_hexLength(hex);
    if (it === 4 ? true : it === 8) {
      tmp_2 = parseHex(hex, 3);
    } else {
      tmp_2 = 255;
    }
    return this.b1f(tmp, tmp_0, tmp_1, tmp_2);
  }
  setMetadataFor(RGBColorSpace, 'RGBColorSpace', interfaceMeta);
  setMetadataFor(Companion_2, 'Companion', objectMeta, VOID, [RGBColorSpace]);
  setMetadataFor(RGB, 'RGB', classMeta, VOID, [Color]);
  setMetadataFor(RGBColorSpaces, 'RGBColorSpaces', objectMeta);
  setMetadataFor(SRGB, 'SRGB', objectMeta, VOID, [RGBColorSpace]);
  setMetadataFor(RGBColorSpaceImpl, 'RGBColorSpaceImpl', classMeta, VOID, [RGBColorSpace]);
  setMetadataFor(SRGBTransferFunctions, 'SRGBTransferFunctions', objectMeta);
  setMetadataFor(ACESccTransferFunctions, 'ACESccTransferFunctions', objectMeta);
  setMetadataFor(ACEScctTransferFunctions, 'ACEScctTransferFunctions', objectMeta);
  setMetadataFor(BT2020TransferFunctions, 'BT2020TransferFunctions', objectMeta);
  setMetadataFor(BT709TransferFunctions, 'BT709TransferFunctions', objectMeta);
  setMetadataFor(ROMMTransferFunctions, 'ROMMTransferFunctions', objectMeta);
  setMetadataFor(XYZColorSpace, 'XYZColorSpace', interfaceMeta);
  setMetadataFor(Companion_3, 'Companion', objectMeta, VOID, [XYZColorSpace]);
  setMetadataFor(XYZ, 'XYZ', classMeta, VOID, [Color]);
  setMetadataFor(XYZColorSpaces, 'XYZColorSpaces', objectMeta);
  setMetadataFor(XYZColorSpaceImpl, 'XYZColorSpaceImpl', classMeta, VOID, [XYZColorSpace]);
  setMetadataFor(xyY, 'xyY', classMeta);
  //endregion
  function Color() {
  }
  function ColorComponentInfo(name, isPolar, min, max) {
    this.s1c_1 = name;
    this.t1c_1 = isPolar;
    this.u1c_1 = min;
    this.v1c_1 = max;
    // Inline function 'kotlin.require' call
    // Inline function 'kotlin.contracts.contract' call
    if (!(this.u1c_1 <= this.v1c_1)) {
      // Inline function 'com.github.ajalt.colormath.ColorComponentInfo.<anonymous>' call
      var message = 'min must be less than or equal to max';
      throw IllegalArgumentException_init_$Create$(toString(message));
    }
  }
  function WhitePoint(name, chromaticity) {
    this.w1c_1 = name;
    this.x1c_1 = chromaticity;
  }
  protoOf(WhitePoint).toString = function () {
    return this.w1c_1;
  };
  protoOf(WhitePoint).hashCode = function () {
    var result = getStringHashCode(this.w1c_1);
    result = imul(result, 31) + this.x1c_1.hashCode() | 0;
    return result;
  };
  protoOf(WhitePoint).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof WhitePoint))
      return false;
    var tmp0_other_with_cast = other instanceof WhitePoint ? other : THROW_CCE();
    if (!(this.w1c_1 === tmp0_other_with_cast.w1c_1))
      return false;
    if (!this.x1c_1.equals(tmp0_other_with_cast.x1c_1))
      return false;
    return true;
  };
  function Illuminant() {
    Illuminant_instance = this;
    this.y1c_1 = new WhitePoint('A', xyY_init_$Create$(0.44758, 0.40745));
    this.z1c_1 = new WhitePoint('B', xyY_init_$Create$(0.34842, 0.35161));
    this.a1d_1 = new WhitePoint('C', xyY_init_$Create$(0.31006, 0.31616));
    this.b1d_1 = new WhitePoint('D50', xyY_init_$Create$(0.3457, 0.3585));
    this.c1d_1 = new WhitePoint('D55', xyY_init_$Create$(0.33243, 0.34744));
    this.d1d_1 = new WhitePoint('D65', xyY_init_$Create$(0.3127, 0.329));
    this.e1d_1 = new WhitePoint('D75', xyY_init_$Create$(0.29903, 0.31488));
    this.f1d_1 = new WhitePoint('E', xyY_init_$Create$(0.3333333333333333, 0.3333333333333333));
  }
  var Illuminant_instance;
  function Illuminant_getInstance() {
    if (Illuminant_instance == null)
      new Illuminant();
    return Illuminant_instance;
  }
  function get_alphaInfo() {
    _init_properties_ColorSpaceUtils_kt__cnwylg();
    return alphaInfo;
  }
  var alphaInfo;
  function zeroOneComponentInfo(name) {
    _init_properties_ColorSpaceUtils_kt__cnwylg();
    // Inline function 'kotlin.collections.buildList' call
    // Inline function 'kotlin.contracts.contract' call
    // Inline function 'kotlin.collections.buildListInternal' call
    // Inline function 'kotlin.apply' call
    var this_0 = ArrayList_init_$Create$();
    // Inline function 'kotlin.contracts.contract' call
    // Inline function 'com.github.ajalt.colormath.internal.zeroOneComponentInfo.<anonymous>' call
    // Inline function 'kotlin.text.mapTo' call
    var inductionVariable = 0;
    while (inductionVariable < charSequenceLength(name)) {
      var item = charSequenceGet(name, inductionVariable);
      inductionVariable = inductionVariable + 1 | 0;
      // Inline function 'com.github.ajalt.colormath.internal.zeroOneComponentInfo.<anonymous>.<anonymous>' call
      var tmp$ret$0 = new ColorComponentInfo(toString_0(item), false, 0.0, 1.0);
      this_0.o(tmp$ret$0);
    }
    this_0.o(get_alphaInfo());
    return this_0.z2();
  }
  function polarComponentInfo(name, l, r) {
    _init_properties_ColorSpaceUtils_kt__cnwylg();
    // Inline function 'kotlin.collections.buildList' call
    // Inline function 'kotlin.contracts.contract' call
    // Inline function 'kotlin.collections.buildListInternal' call
    // Inline function 'kotlin.apply' call
    var this_0 = ArrayList_init_$Create$();
    // Inline function 'kotlin.contracts.contract' call
    // Inline function 'com.github.ajalt.colormath.internal.polarComponentInfo.<anonymous>' call
    // Inline function 'kotlin.text.mapTo' call
    var inductionVariable = 0;
    while (inductionVariable < charSequenceLength(name)) {
      var item = charSequenceGet(name, inductionVariable);
      inductionVariable = inductionVariable + 1 | 0;
      // Inline function 'com.github.ajalt.colormath.internal.polarComponentInfo.<anonymous>.<anonymous>' call
      var tmp$ret$0 = new ColorComponentInfo(toString_0(item), item === _Char___init__impl__6a9atx(72), item === _Char___init__impl__6a9atx(72) ? 0.0 : l, item === _Char___init__impl__6a9atx(72) ? 360.0 : r);
      this_0.o(tmp$ret$0);
    }
    this_0.o(get_alphaInfo());
    return this_0.z2();
  }
  function componentInfoList(c) {
    _init_properties_ColorSpaceUtils_kt__cnwylg();
    return listOf(arrayConcat([c, [get_alphaInfo()]]));
  }
  var properties_initialized_ColorSpaceUtils_kt_kskdoe;
  function _init_properties_ColorSpaceUtils_kt__cnwylg() {
    if (!properties_initialized_ColorSpaceUtils_kt_kskdoe) {
      properties_initialized_ColorSpaceUtils_kt_kskdoe = true;
      alphaInfo = new ColorComponentInfo('alpha', false, 0.0, 1.0);
    }
  }
  function get_CAT02_XYZ_TO_LMS() {
    _init_properties_Constants_kt__atb1ur();
    return CAT02_XYZ_TO_LMS;
  }
  var CAT02_XYZ_TO_LMS;
  function get_CAT02_LMS_TO_XYZ() {
    _init_properties_Constants_kt__atb1ur();
    return CAT02_LMS_TO_XYZ;
  }
  var CAT02_LMS_TO_XYZ;
  var properties_initialized_Constants_kt_w4w61t;
  function _init_properties_Constants_kt__atb1ur() {
    if (!properties_initialized_Constants_kt_w4w61t) {
      properties_initialized_Constants_kt_w4w61t = true;
      CAT02_XYZ_TO_LMS = _Matrix___init__impl__q3kp4w_0(0.7328, 0.4296, -0.1624, -0.7036, 1.6975, 0.0061, 0.003, 0.0136, 0.9834);
      CAT02_LMS_TO_XYZ = inverse(get_CAT02_XYZ_TO_LMS());
    }
  }
  function spow(_this__u8e3s4, p) {
    return spow_0(_this__u8e3s4, p);
  }
  function normalizeDeg(_this__u8e3s4) {
    return (_this__u8e3s4 % 360.0 + 360.0) % 360.0;
  }
  function spow_0(_this__u8e3s4, p) {
    // Inline function 'kotlin.math.pow' call
    // Inline function 'kotlin.math.absoluteValue' call
    var this_0 = Math.abs(_this__u8e3s4);
    var tmp$ret$1 = Math.pow(this_0, p);
    return withSign(tmp$ret$1, _this__u8e3s4);
  }
  function normalizeDeg_0(_this__u8e3s4) {
    return (_this__u8e3s4 % 360.0 + 360.0) % 360.0;
  }
  function _Matrix___init__impl__q3kp4w(rowMajor) {
    return rowMajor;
  }
  function _Matrix___get_rowMajor__impl__vmgxkq($this) {
    return $this;
  }
  function _Matrix___init__impl__q3kp4w_0(v00, v10, v20, v01, v11, v21, v02, v12, v22) {
    // Inline function 'kotlin.floatArrayOf' call
    var tmp$ret$0 = new Float32Array([v00, v10, v20, v01, v11, v21, v02, v12, v22]);
    return _Matrix___init__impl__q3kp4w(tmp$ret$0);
  }
  function Matrix__copy_impl_kmkvzd($this) {
    // Inline function 'kotlin.collections.copyOf' call
    // Inline function 'kotlin.js.asDynamic' call
    var tmp$ret$1 = _Matrix___get_rowMajor__impl__vmgxkq($this).slice();
    return _Matrix___init__impl__q3kp4w(tmp$ret$1);
  }
  function Matrix__get_impl_xogbpk($this, x, y) {
    return _Matrix___get_rowMajor__impl__vmgxkq($this)[imul(y, 3) + x | 0];
  }
  function Matrix__set_impl_s2l54c($this, x, y, value) {
    _Matrix___get_rowMajor__impl__vmgxkq($this)[imul(y, 3) + x | 0] = value;
  }
  function Matrix__set_impl_s2l54c_0($this, x, y, value) {
    return Matrix__set_impl_s2l54c($this, x, y, value);
  }
  function inverse(_this__u8e3s4, inPlace) {
    inPlace = inPlace === VOID ? false : inPlace;
    var a = Matrix__get_impl_xogbpk(_this__u8e3s4, 0, 0);
    var b = Matrix__get_impl_xogbpk(_this__u8e3s4, 1, 0);
    var c = Matrix__get_impl_xogbpk(_this__u8e3s4, 2, 0);
    var d = Matrix__get_impl_xogbpk(_this__u8e3s4, 0, 1);
    var e = Matrix__get_impl_xogbpk(_this__u8e3s4, 1, 1);
    var f = Matrix__get_impl_xogbpk(_this__u8e3s4, 2, 1);
    var g = Matrix__get_impl_xogbpk(_this__u8e3s4, 0, 2);
    var h = Matrix__get_impl_xogbpk(_this__u8e3s4, 1, 2);
    var i = Matrix__get_impl_xogbpk(_this__u8e3s4, 2, 2);
    var A = e * i - h * f;
    var B = h * c - b * i;
    var C = b * f - e * c;
    var det = a * A + d * B + g * C;
    var out = inPlace ? _this__u8e3s4 : Matrix__copy_impl_kmkvzd(_this__u8e3s4);
    Matrix__set_impl_s2l54c_0(out, 0, 0, A / det);
    Matrix__set_impl_s2l54c_0(out, 0, 1, (g * f - d * i) / det);
    Matrix__set_impl_s2l54c_0(out, 0, 2, (d * h - g * e) / det);
    Matrix__set_impl_s2l54c_0(out, 1, 0, B / det);
    Matrix__set_impl_s2l54c_0(out, 1, 1, (a * i - g * c) / det);
    Matrix__set_impl_s2l54c_0(out, 1, 2, (g * b - a * h) / det);
    Matrix__set_impl_s2l54c_0(out, 2, 0, C / det);
    Matrix__set_impl_s2l54c_0(out, 2, 1, (d * c - a * f) / det);
    Matrix__set_impl_s2l54c_0(out, 2, 2, (a * e - d * b) / det);
    return out;
  }
  function scalarDiv(_this__u8e3s4, x, inPlace) {
    inPlace = inPlace === VOID ? false : inPlace;
    var out = _Matrix___get_rowMajor__impl__vmgxkq(inPlace ? _this__u8e3s4 : Matrix__copy_impl_kmkvzd(_this__u8e3s4));
    var inductionVariable = 0;
    var last = out.length - 1 | 0;
    if (inductionVariable <= last)
      do {
        var i = inductionVariable;
        inductionVariable = inductionVariable + 1 | 0;
        out[i] = out[i] / x;
      }
       while (inductionVariable <= last);
    return _Matrix___init__impl__q3kp4w(out);
  }
  function dot(_this__u8e3s4, other) {
    return _Matrix___init__impl__q3kp4w_0(dot$f(_this__u8e3s4, other, 0, 0), dot$f(_this__u8e3s4, other, 1, 0), dot$f(_this__u8e3s4, other, 2, 0), dot$f(_this__u8e3s4, other, 0, 1), dot$f(_this__u8e3s4, other, 1, 1), dot$f(_this__u8e3s4, other, 2, 1), dot$f(_this__u8e3s4, other, 0, 2), dot$f(_this__u8e3s4, other, 1, 2), dot$f(_this__u8e3s4, other, 2, 2));
  }
  function dotDiagonal(_this__u8e3s4, v0, v1, v2) {
    return _Matrix___init__impl__q3kp4w_0(Matrix__get_impl_xogbpk(_this__u8e3s4, 0, 0) * v0, Matrix__get_impl_xogbpk(_this__u8e3s4, 1, 0) * v1, Matrix__get_impl_xogbpk(_this__u8e3s4, 2, 0) * v2, Matrix__get_impl_xogbpk(_this__u8e3s4, 0, 1) * v0, Matrix__get_impl_xogbpk(_this__u8e3s4, 1, 1) * v1, Matrix__get_impl_xogbpk(_this__u8e3s4, 2, 1) * v2, Matrix__get_impl_xogbpk(_this__u8e3s4, 0, 2) * v0, Matrix__get_impl_xogbpk(_this__u8e3s4, 1, 2) * v1, Matrix__get_impl_xogbpk(_this__u8e3s4, 2, 2) * v2);
  }
  function _Vector___init__impl__y7x4qq(values) {
    return values;
  }
  function _Vector___get_values__impl__3gdbp5($this) {
    return $this;
  }
  function _Vector___init__impl__y7x4qq_0(v0, v1, v2) {
    // Inline function 'kotlin.floatArrayOf' call
    var tmp$ret$0 = new Float32Array([v0, v1, v2]);
    return _Vector___init__impl__y7x4qq(tmp$ret$0);
  }
  function _Vector___get_l__impl__envr1l($this) {
    return _Vector___get_values__impl__3gdbp5($this)[0];
  }
  function _Vector___get_m__impl__e5qq0m($this) {
    return _Vector___get_values__impl__3gdbp5($this)[1];
  }
  function _Vector___get_s__impl__pzuljk($this) {
    return _Vector___get_values__impl__3gdbp5($this)[2];
  }
  function dot_0(_this__u8e3s4, v0, v1, v2) {
    // Inline function 'com.github.ajalt.colormath.internal.dot' call
    return _Vector___init__impl__y7x4qq_0(Matrix__get_impl_xogbpk(_this__u8e3s4, 0, 0) * v0 + Matrix__get_impl_xogbpk(_this__u8e3s4, 1, 0) * v1 + Matrix__get_impl_xogbpk(_this__u8e3s4, 2, 0) * v2, Matrix__get_impl_xogbpk(_this__u8e3s4, 0, 1) * v0 + Matrix__get_impl_xogbpk(_this__u8e3s4, 1, 1) * v1 + Matrix__get_impl_xogbpk(_this__u8e3s4, 2, 1) * v2, Matrix__get_impl_xogbpk(_this__u8e3s4, 0, 2) * v0 + Matrix__get_impl_xogbpk(_this__u8e3s4, 1, 2) * v1 + Matrix__get_impl_xogbpk(_this__u8e3s4, 2, 2) * v2);
  }
  function dot$f($this_dot, $other, x, y) {
    return Matrix__get_impl_xogbpk($this_dot, 0, y) * Matrix__get_impl_xogbpk($other, x, 0) + Matrix__get_impl_xogbpk($this_dot, 1, y) * Matrix__get_impl_xogbpk($other, x, 1) + Matrix__get_impl_xogbpk($this_dot, 2, y) * Matrix__get_impl_xogbpk($other, x, 2);
  }
  function Companion() {
    Companion_instance = this;
    this.g1d_1 = componentInfoList([new ColorComponentInfo('code', false, 30.0, 107.0)]);
  }
  protoOf(Companion).h1d = function () {
    return this.g1d_1;
  };
  var Companion_instance;
  function Companion_getInstance() {
    if (Companion_instance == null)
      new Companion();
    return Companion_instance;
  }
  function Ansi16(code) {
    Companion_getInstance();
    this.i1d_1 = code;
  }
  protoOf(Ansi16).k1c = function () {
    return Companion_getInstance();
  };
  protoOf(Ansi16).l1c = function () {
    switch (this.i1d_1) {
      case 30:
      case 40:
        return Companion_getInstance_2().j1d(0.0, 0.0, 0.0);
      case 90:
      case 100:
        return Companion_getInstance_2().k1d(128, 128, 128);
      case 37:
      case 47:
        return Companion_getInstance_2().k1d(192, 192, 192);
      case 97:
      case 107:
        return Companion_getInstance_2().j1d(1.0, 1.0, 1.0);
    }
    var color = this.i1d_1 % 10 | 0;
    var mul = this.i1d_1 > 50 ? 1.0 : 0.5;
    var r = (color % 2 | 0) * mul;
    var g = ((color / 2 | 0) % 2 | 0) * mul;
    var b = ((color / 4 | 0) % 2 | 0) * mul;
    return Companion_getInstance_2().j1d(r, g, b);
  };
  protoOf(Ansi16).toString = function () {
    return 'Ansi16(code=' + this.i1d_1 + ')';
  };
  protoOf(Ansi16).hashCode = function () {
    return this.i1d_1;
  };
  protoOf(Ansi16).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof Ansi16))
      return false;
    var tmp0_other_with_cast = other instanceof Ansi16 ? other : THROW_CCE();
    if (!(this.i1d_1 === tmp0_other_with_cast.i1d_1))
      return false;
    return true;
  };
  function Companion_0() {
    Companion_instance_0 = this;
    this.l1d_1 = componentInfoList([new ColorComponentInfo('code', false, 0.0, 255.0)]);
  }
  protoOf(Companion_0).h1d = function () {
    return this.l1d_1;
  };
  var Companion_instance_0;
  function Companion_getInstance_0() {
    if (Companion_instance_0 == null)
      new Companion_0();
    return Companion_instance_0;
  }
  function Ansi256(code) {
    Companion_getInstance_0();
    this.m1d_1 = code;
  }
  protoOf(Ansi256).k1c = function () {
    return Companion_getInstance_0();
  };
  protoOf(Ansi256).l1c = function () {
    if (this.m1d_1 < 16)
      return this.n1d().l1c();
    if (this.m1d_1 >= 232) {
      var c = imul(this.m1d_1 - 232 | 0, 10) + 8 | 0;
      return Companion_getInstance_2().k1d(c, c, c);
    }
    var c_0 = this.m1d_1 - 16 | 0;
    var rem = c_0 % 36 | 0;
    // Inline function 'kotlin.math.floor' call
    var x = c_0 / 36.0;
    var r = Math.floor(x) / 5.0;
    // Inline function 'kotlin.math.floor' call
    var x_0 = rem / 6.0;
    var g = Math.floor(x_0) / 5.0;
    var b = (rem % 6 | 0) / 5.0;
    return Companion_getInstance_2().o1d(r, g, b);
  };
  protoOf(Ansi256).n1d = function () {
    return this.m1d_1 < 8 ? new Ansi16(this.m1d_1 + 30 | 0) : this.m1d_1 < 16 ? new Ansi16((this.m1d_1 - 8 | 0) + 90 | 0) : this.l1c().n1d();
  };
  protoOf(Ansi256).toString = function () {
    return 'Ansi256(code=' + this.m1d_1 + ')';
  };
  protoOf(Ansi256).hashCode = function () {
    return this.m1d_1;
  };
  protoOf(Ansi256).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof Ansi256))
      return false;
    var tmp0_other_with_cast = other instanceof Ansi256 ? other : THROW_CCE();
    if (!(this.m1d_1 === tmp0_other_with_cast.m1d_1))
      return false;
    return true;
  };
  function Companion_1() {
    Companion_instance_1 = this;
    this.p1d_1 = polarComponentInfo('HSV', 0.0, 1.0);
  }
  protoOf(Companion_1).h1d = function () {
    return this.p1d_1;
  };
  var Companion_instance_1;
  function Companion_getInstance_1() {
    if (Companion_instance_1 == null)
      new Companion_1();
    return Companion_instance_1;
  }
  function toSRGB$f(h, v, s, n) {
    var k = (n + h) % 6;
    var tmp = v * s;
    // Inline function 'kotlin.comparisons.minOf' call
    var b = 4 - k;
    var tmp$ret$0 = Math.min(k, b, 1.0);
    return v - tmp * coerceAtLeast(tmp$ret$0, 0.0);
  }
  function HSV(h, s, v, alpha) {
    Companion_getInstance_1();
    alpha = alpha === VOID ? 1.0 : alpha;
    this.q1d_1 = h;
    this.r1d_1 = s;
    this.s1d_1 = v;
    this.t1d_1 = alpha;
  }
  protoOf(HSV).k1c = function () {
    return Companion_getInstance_1();
  };
  protoOf(HSV).l1c = function () {
    if (this.r1d_1 < 1.0E-7)
      return Companion_getInstance_2().v1d(this.s1d_1, this.s1d_1, this.s1d_1, this.t1d_1);
    var v = this.s1d_1;
    var h = normalizeDeg_0(this.q1d_1) / 60.0;
    var s = this.r1d_1;
    return SRGB_getInstance().v1d(toSRGB$f(h, v, s, 5), toSRGB$f(h, v, s, 3), toSRGB$f(h, v, s, 1), this.t1d_1);
  };
  protoOf(HSV).toString = function () {
    return 'HSV(h=' + this.q1d_1 + ', s=' + this.r1d_1 + ', v=' + this.s1d_1 + ', alpha=' + this.t1d_1 + ')';
  };
  protoOf(HSV).hashCode = function () {
    var result = getNumberHashCode(this.q1d_1);
    result = imul(result, 31) + getNumberHashCode(this.r1d_1) | 0;
    result = imul(result, 31) + getNumberHashCode(this.s1d_1) | 0;
    result = imul(result, 31) + getNumberHashCode(this.t1d_1) | 0;
    return result;
  };
  protoOf(HSV).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof HSV))
      return false;
    var tmp0_other_with_cast = other instanceof HSV ? other : THROW_CCE();
    if (!equals(this.q1d_1, tmp0_other_with_cast.q1d_1))
      return false;
    if (!equals(this.r1d_1, tmp0_other_with_cast.r1d_1))
      return false;
    if (!equals(this.s1d_1, tmp0_other_with_cast.s1d_1))
      return false;
    if (!equals(this.t1d_1, tmp0_other_with_cast.t1d_1))
      return false;
    return true;
  };
  function get_ICTCP_RGB_TO_LMS() {
    _init_properties_ICtCp_kt__7vx7or();
    return ICTCP_RGB_TO_LMS;
  }
  var ICTCP_RGB_TO_LMS;
  function get_ICTCP_LMS_TO_ICTCP() {
    _init_properties_ICtCp_kt__7vx7or();
    return ICTCP_LMS_TO_ICTCP;
  }
  var ICTCP_LMS_TO_ICTCP;
  function get_ICTCP_LMS_to_RGB() {
    _init_properties_ICtCp_kt__7vx7or();
    return ICTCP_LMS_to_RGB;
  }
  var ICTCP_LMS_to_RGB;
  function get_ICTCP_ICTCP_to_LMS() {
    _init_properties_ICtCp_kt__7vx7or();
    return ICTCP_ICTCP_to_LMS;
  }
  var ICTCP_ICTCP_to_LMS;
  function get_ICTCP_CROSSTALK() {
    _init_properties_ICtCp_kt__7vx7or();
    return ICTCP_CROSSTALK;
  }
  var ICTCP_CROSSTALK;
  function get_HPE_XYZ_TO_LMS() {
    _init_properties_ICtCp_kt__7vx7or();
    return HPE_XYZ_TO_LMS;
  }
  var HPE_XYZ_TO_LMS;
  function get_ICTCP_XYZ_TO_LMS() {
    _init_properties_ICtCp_kt__7vx7or();
    return ICTCP_XYZ_TO_LMS;
  }
  var ICTCP_XYZ_TO_LMS;
  var ICTCP_LMS_TO_XYZ;
  function ICtCp() {
  }
  protoOf(ICtCp).b1e = function () {
    var fo = RGBColorSpaces_getInstance().j1e_1.o1e();
    // Inline function 'com.github.ajalt.colormath.internal.dot' call
    var this_0 = get_ICTCP_ICTCP_to_LMS();
    var v0 = this.x1d_1;
    var v1 = this.y1d_1;
    var v2 = this.z1d_1;
    // Inline function 'com.github.ajalt.colormath.model.ICtCp.toBT2020.<anonymous>' call
    var l = Matrix__get_impl_xogbpk(this_0, 0, 0) * v0 + Matrix__get_impl_xogbpk(this_0, 1, 0) * v1 + Matrix__get_impl_xogbpk(this_0, 2, 0) * v2;
    var m = Matrix__get_impl_xogbpk(this_0, 0, 1) * v0 + Matrix__get_impl_xogbpk(this_0, 1, 1) * v1 + Matrix__get_impl_xogbpk(this_0, 2, 1) * v2;
    var s = Matrix__get_impl_xogbpk(this_0, 0, 2) * v0 + Matrix__get_impl_xogbpk(this_0, 1, 2) * v1 + Matrix__get_impl_xogbpk(this_0, 2, 2) * v2;
    // Inline function 'com.github.ajalt.colormath.internal.dot' call
    var this_1 = get_ICTCP_LMS_to_RGB();
    var v0_0 = PqNonlinearity_instance.x1e(l);
    var v1_0 = PqNonlinearity_instance.x1e(m);
    var v2_0 = PqNonlinearity_instance.x1e(s);
    // Inline function 'com.github.ajalt.colormath.model.ICtCp.toBT2020.<anonymous>.<anonymous>' call
    var r = Matrix__get_impl_xogbpk(this_1, 0, 0) * v0_0 + Matrix__get_impl_xogbpk(this_1, 1, 0) * v1_0 + Matrix__get_impl_xogbpk(this_1, 2, 0) * v2_0;
    var g = Matrix__get_impl_xogbpk(this_1, 0, 1) * v0_0 + Matrix__get_impl_xogbpk(this_1, 1, 1) * v1_0 + Matrix__get_impl_xogbpk(this_1, 2, 1) * v2_0;
    var b = Matrix__get_impl_xogbpk(this_1, 0, 2) * v0_0 + Matrix__get_impl_xogbpk(this_1, 1, 2) * v1_0 + Matrix__get_impl_xogbpk(this_1, 2, 2) * v2_0;
    return RGBColorSpaces_getInstance().j1e_1.v1d(fo.y1e(r), fo.y1e(g), fo.y1e(b), this.a1e_1);
  };
  function PqNonlinearity() {
    this.p1e_1 = 0.1593017578125;
    this.q1e_1 = 78.84375;
    this.r1e_1 = 0.8359375;
    this.s1e_1 = 18.8515625;
    this.t1e_1 = 18.6875;
    this.u1e_1 = 10000.0;
    this.v1e_1 = 6.277394636015326;
    this.w1e_1 = 0.012683313515655966;
  }
  protoOf(PqNonlinearity).x1e = function (x) {
    var vp = spow(x, 0.012683313515655966);
    var n = coerceAtLeast(vp - 0.8359375, 0.0);
    var l = spow_0(n / (18.8515625 - 18.6875 * vp), 6.277394636015326);
    return 10000.0 * l;
  };
  protoOf(PqNonlinearity).y1e = function (x) {
    var yp = spow_0(x / 10000.0, 0.1593017578125);
    return spow_0((0.8359375 + 18.8515625 * yp) / (1.0 + 18.6875 * yp), 78.84375);
  };
  var PqNonlinearity_instance;
  function PqNonlinearity_getInstance() {
    return PqNonlinearity_instance;
  }
  var properties_initialized_ICtCp_kt_w6y8uv;
  function _init_properties_ICtCp_kt__7vx7or() {
    if (!properties_initialized_ICtCp_kt_w6y8uv) {
      properties_initialized_ICtCp_kt_w6y8uv = true;
      ICTCP_RGB_TO_LMS = scalarDiv(_Matrix___init__impl__q3kp4w_0(1688.0, 2146.0, 262.0, 683.0, 2951.0, 462.0, 99.0, 309.0, 3688.0), 4096.0, true);
      ICTCP_LMS_TO_ICTCP = scalarDiv(_Matrix___init__impl__q3kp4w_0(2048.0, 2048.0, 0.0, 6610.0, -13613.0, 7003.0, 17933.0, -17390.0, -543.0), 4096.0, true);
      ICTCP_LMS_to_RGB = inverse(get_ICTCP_RGB_TO_LMS());
      ICTCP_ICTCP_to_LMS = inverse(get_ICTCP_LMS_TO_ICTCP());
      ICTCP_CROSSTALK = _Matrix___init__impl__q3kp4w_0(0.92, 0.04, 0.04, 0.04, 0.92, 0.04, 0.04, 0.04, 0.92);
      HPE_XYZ_TO_LMS = _Matrix___init__impl__q3kp4w_0(0.4002, 0.7076, -0.0808, -0.2263, 1.1653, 0.0457, 0.0, 0.0, 0.9182);
      ICTCP_XYZ_TO_LMS = dot(get_ICTCP_CROSSTALK(), get_HPE_XYZ_TO_LMS());
      ICTCP_LMS_TO_XYZ = inverse(get_ICTCP_XYZ_TO_LMS());
    }
  }
  function GammaTransferFunctions(gamma) {
    this.z1e_1 = gamma;
  }
  protoOf(GammaTransferFunctions).x1e = function (x) {
    return spow(x, this.z1e_1);
  };
  protoOf(GammaTransferFunctions).y1e = function (x) {
    return spow(x, 1.0 / this.z1e_1);
  };
  protoOf(GammaTransferFunctions).toString = function () {
    return 'GammaTransferFunctions(gamma=' + this.z1e_1 + ')';
  };
  protoOf(GammaTransferFunctions).hashCode = function () {
    return getNumberHashCode(this.z1e_1);
  };
  protoOf(GammaTransferFunctions).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof GammaTransferFunctions))
      return false;
    var tmp0_other_with_cast = other instanceof GammaTransferFunctions ? other : THROW_CCE();
    if (!equals(this.z1e_1, tmp0_other_with_cast.z1e_1))
      return false;
    return true;
  };
  function LinearTransferFunctions() {
  }
  protoOf(LinearTransferFunctions).x1e = function (x) {
    return x;
  };
  protoOf(LinearTransferFunctions).y1e = function (x) {
    return x;
  };
  var LinearTransferFunctions_instance;
  function LinearTransferFunctions_getInstance() {
    return LinearTransferFunctions_instance;
  }
  function RGBColorSpace() {
  }
  function Companion_2() {
    Companion_instance_2 = this;
    this.u1d_1 = RGBColorSpaces_getInstance().c1e_1;
  }
  protoOf(Companion_2).h1d = function () {
    return this.u1d_1.h1d();
  };
  protoOf(Companion_2).e1f = function () {
    return this.u1d_1.e1f();
  };
  protoOf(Companion_2).d1f = function () {
    return this.u1d_1.d1f();
  };
  protoOf(Companion_2).a12 = function () {
    return this.u1d_1.a12();
  };
  protoOf(Companion_2).o1e = function () {
    return this.u1d_1.o1e();
  };
  protoOf(Companion_2).f1f = function () {
    return this.u1d_1.f1f();
  };
  protoOf(Companion_2).b1f = function (r, g, b, alpha) {
    return this.u1d_1.b1f(r, g, b, alpha);
  };
  protoOf(Companion_2).v1d = function (r, g, b, alpha) {
    return this.u1d_1.v1d(r, g, b, alpha);
  };
  protoOf(Companion_2).a1f = function (r, g, b, alpha) {
    return this.u1d_1.a1f(r, g, b, alpha);
  };
  protoOf(Companion_2).c1f = function (hex) {
    return this.u1d_1.c1f(hex);
  };
  protoOf(Companion_2).equals = function (other) {
    return equals(RGBColorSpaces_getInstance().c1e_1, other);
  };
  protoOf(Companion_2).hashCode = function () {
    return hashCode(RGBColorSpaces_getInstance().c1e_1);
  };
  var Companion_instance_2;
  function Companion_getInstance_2() {
    if (Companion_instance_2 == null)
      new Companion_2();
    return Companion_instance_2;
  }
  function clamp$copy(receiver, p0, p1, p2, p3) {
    return receiver.g1f(p0, p1, p2, p3);
  }
  function RGB(r, g, b, alpha, space) {
    Companion_getInstance_2();
    this.n1c_1 = r;
    this.o1c_1 = g;
    this.p1c_1 = b;
    this.q1c_1 = alpha;
    this.r1c_1 = space;
  }
  protoOf(RGB).k1c = function () {
    return this.r1c_1;
  };
  protoOf(RGB).h1f = function () {
    // Inline function 'kotlin.math.roundToInt' call
    var this_0 = this.n1c_1 * 255;
    return roundToInt(this_0);
  };
  protoOf(RGB).i1f = function () {
    // Inline function 'kotlin.math.roundToInt' call
    var this_0 = this.o1c_1 * 255;
    return roundToInt(this_0);
  };
  protoOf(RGB).j1f = function () {
    // Inline function 'kotlin.math.roundToInt' call
    var this_0 = this.p1c_1 * 255;
    return roundToInt(this_0);
  };
  protoOf(RGB).k1f = function (space) {
    var f = SRGB_getInstance().o1e();
    return equals(this.r1c_1, space) ? this : (equals(this.r1c_1, SRGB_getInstance()) ? equals(space, RGBColorSpaces_getInstance().d1e_1) : false) ? space.v1d(f.x1e(this.n1c_1), f.x1e(this.o1c_1), f.x1e(this.p1c_1), this.q1c_1) : (equals(this.r1c_1, RGBColorSpaces_getInstance().d1e_1) ? equals(space, SRGB_getInstance()) : false) ? space.v1d(f.y1e(this.n1c_1), f.y1e(this.o1c_1), f.y1e(this.p1c_1), this.q1c_1) : this.m1c().q1f(space);
  };
  protoOf(RGB).r1f = function () {
    var tmp$ret$3;
    $l$block: {
      // Inline function 'com.github.ajalt.colormath.model.RGB.srgbHueMinMaxChroma' call
      // Inline function 'com.github.ajalt.colormath.model.RGB.toSRGB' call
      var $this$toSRGB = this.k1f(SRGB_getInstance());
      var r = $this$toSRGB.n1c_1;
      var g = $this$toSRGB.o1c_1;
      var b = $this$toSRGB.p1c_1;
      // Inline function 'kotlin.comparisons.minOf' call
      var min = Math.min(r, g, b);
      // Inline function 'kotlin.comparisons.maxOf' call
      var max = Math.max(r, g, b);
      var chroma = max - min;
      var tmp;
      if (chroma < 1.0E-7) {
        tmp = NaN;
      } else if (r === max) {
        tmp = (g - b) / chroma;
      } else if (g === max) {
        tmp = 2 + (b - r) / chroma;
      } else if (b === max) {
        tmp = 4 + (r - g) / chroma;
      } else {
        tmp = 0.0;
      }
      var h = tmp * 60;
      // Inline function 'com.github.ajalt.colormath.model.RGB.toHSV.<anonymous>' call
      var h_0 = normalizeDeg(h);
      var s = max === 0.0 ? 0.0 : chroma / max;
      tmp$ret$3 = new HSV(h_0, s, max, this.q1c_1);
      break $l$block;
    }
    return tmp$ret$3;
  };
  protoOf(RGB).m1c = function () {
    var f = this.r1c_1.o1e();
    // Inline function 'com.github.ajalt.colormath.internal.dot' call
    var this_0 = _Matrix___init__impl__q3kp4w(this.r1c_1.d1f());
    var v0 = f.x1e(this.n1c_1);
    var v1 = f.x1e(this.o1c_1);
    var v2 = f.x1e(this.p1c_1);
    // Inline function 'com.github.ajalt.colormath.model.RGB.toXYZ.<anonymous>' call
    var x = Matrix__get_impl_xogbpk(this_0, 0, 0) * v0 + Matrix__get_impl_xogbpk(this_0, 1, 0) * v1 + Matrix__get_impl_xogbpk(this_0, 2, 0) * v2;
    var y = Matrix__get_impl_xogbpk(this_0, 0, 1) * v0 + Matrix__get_impl_xogbpk(this_0, 1, 1) * v1 + Matrix__get_impl_xogbpk(this_0, 2, 1) * v2;
    var z = Matrix__get_impl_xogbpk(this_0, 0, 2) * v0 + Matrix__get_impl_xogbpk(this_0, 1, 2) * v1 + Matrix__get_impl_xogbpk(this_0, 2, 2) * v2;
    return XYZColorSpace_0(this.r1c_1.f1f()).v1d(x, y, z, this.q1c_1);
  };
  protoOf(RGB).n1d = function () {
    // Inline function 'com.github.ajalt.colormath.model.RGB.toSRGB' call
    var $this$toSRGB = this.k1f(SRGB_getInstance());
    // Inline function 'kotlin.math.roundToInt' call
    var this_0 = $this$toSRGB.r1f().s1d_1 * 100;
    var value = roundToInt(this_0);
    if (value === 30)
      return new Ansi16(30);
    var v = value / 50 | 0;
    // Inline function 'kotlin.math.roundToInt' call
    var this_1 = $this$toSRGB.p1c_1;
    var tmp$ret$1 = roundToInt(this_1);
    var tmp = imul(tmp$ret$1, 4);
    // Inline function 'kotlin.math.roundToInt' call
    var this_2 = $this$toSRGB.o1c_1;
    var tmp$ret$2 = roundToInt(this_2);
    var tmp_0 = tmp | imul(tmp$ret$2, 2);
    // Inline function 'kotlin.math.roundToInt' call
    var this_3 = $this$toSRGB.n1c_1;
    var ansi = 30 + (tmp_0 | roundToInt(this_3)) | 0;
    return new Ansi16(v === 2 ? ansi + 60 | 0 : ansi);
  };
  protoOf(RGB).s1f = function () {
    // Inline function 'com.github.ajalt.colormath.model.RGB.toSRGB' call
    var $this$toSRGB = this.k1f(SRGB_getInstance());
    var ri = $this$toSRGB.h1f();
    var gi = $this$toSRGB.i1f();
    var bi = $this$toSRGB.j1f();
    var tmp;
    if (ri === gi ? gi === bi : false) {
      tmp = ri < 8 ? 16 : ri > 248 ? 231 : roundToInt((ri - 8 | 0) / 247.0 * 24.0) + 232 | 0;
    } else {
      // Inline function 'kotlin.math.roundToInt' call
      var this_0 = $this$toSRGB.n1c_1 * 5;
      var tmp$ret$0 = roundToInt(this_0);
      var tmp_0 = 16 + imul(36, tmp$ret$0) | 0;
      // Inline function 'kotlin.math.roundToInt' call
      var this_1 = $this$toSRGB.o1c_1 * 5;
      var tmp$ret$1 = roundToInt(this_1);
      var tmp_1 = tmp_0 + imul(6, tmp$ret$1) | 0;
      // Inline function 'kotlin.math.roundToInt' call
      var this_2 = $this$toSRGB.p1c_1 * 5;
      tmp = tmp_1 + roundToInt(this_2) | 0;
    }
    var code = tmp;
    return new Ansi256(code);
  };
  protoOf(RGB).l1c = function () {
    return this.k1f(RGBColorSpaces_getInstance().c1e_1);
  };
  protoOf(RGB).t1f = function () {
    // Inline function 'com.github.ajalt.colormath.internal.clamp3' call
    var v1 = this.n1c_1;
    var v2 = this.o1c_1;
    var v3 = this.p1c_1;
    var alpha = this.q1c_1;
    var tmp0_container = this.k1c().h1d();
    // Inline function 'kotlin.collections.component1' call
    var c1 = tmp0_container.c1(0);
    // Inline function 'kotlin.collections.component2' call
    var c2 = tmp0_container.c1(1);
    // Inline function 'kotlin.collections.component3' call
    var c3 = tmp0_container.c1(2);
    var tmp;
    var tmp_0;
    var tmp_1;
    var tmp_2;
    var containsLower = c1.u1c_1;
    if (v1 <= c1.v1c_1 ? containsLower <= v1 : false) {
      var containsLower_0 = c2.u1c_1;
      tmp_2 = v2 <= c2.v1c_1 ? containsLower_0 <= v2 : false;
    } else {
      tmp_2 = false;
    }
    if (tmp_2) {
      var containsLower_1 = c3.u1c_1;
      tmp_1 = v3 <= c3.v1c_1 ? containsLower_1 <= v3 : false;
    } else {
      tmp_1 = false;
    }
    if (tmp_1) {
      tmp_0 = 0.0 <= alpha ? alpha <= 1.0 : false;
    } else {
      tmp_0 = false;
    }
    if (tmp_0) {
      tmp = this;
    } else {
      tmp = clamp$copy(this, coerceIn(v1, c1.u1c_1, c1.v1c_1), coerceIn(v2, c2.u1c_1, c2.v1c_1), coerceIn(v3, c3.u1c_1, c3.v1c_1), coerceIn(alpha, 0.0, 1.0));
    }
    return tmp;
  };
  protoOf(RGB).u1f = function (r, g, b, alpha, space) {
    return new RGB(r, g, b, alpha, space);
  };
  protoOf(RGB).g1f = function (r, g, b, alpha, space, $super) {
    r = r === VOID ? this.n1c_1 : r;
    g = g === VOID ? this.o1c_1 : g;
    b = b === VOID ? this.p1c_1 : b;
    alpha = alpha === VOID ? this.q1c_1 : alpha;
    space = space === VOID ? this.r1c_1 : space;
    return $super === VOID ? this.u1f(r, g, b, alpha, space) : $super.u1f.call(this, r, g, b, alpha, space);
  };
  protoOf(RGB).toString = function () {
    return 'RGB(r=' + this.n1c_1 + ', g=' + this.o1c_1 + ', b=' + this.p1c_1 + ', alpha=' + this.q1c_1 + ', space=' + this.r1c_1 + ')';
  };
  protoOf(RGB).hashCode = function () {
    var result = getNumberHashCode(this.n1c_1);
    result = imul(result, 31) + getNumberHashCode(this.o1c_1) | 0;
    result = imul(result, 31) + getNumberHashCode(this.p1c_1) | 0;
    result = imul(result, 31) + getNumberHashCode(this.q1c_1) | 0;
    result = imul(result, 31) + hashCode(this.r1c_1) | 0;
    return result;
  };
  protoOf(RGB).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof RGB))
      return false;
    var tmp0_other_with_cast = other instanceof RGB ? other : THROW_CCE();
    if (!equals(this.n1c_1, tmp0_other_with_cast.n1c_1))
      return false;
    if (!equals(this.o1c_1, tmp0_other_with_cast.o1c_1))
      return false;
    if (!equals(this.p1c_1, tmp0_other_with_cast.p1c_1))
      return false;
    if (!equals(this.q1c_1, tmp0_other_with_cast.q1c_1))
      return false;
    if (!equals(this.r1c_1, tmp0_other_with_cast.r1c_1))
      return false;
    return true;
  };
  function parseHex(_this__u8e3s4, startIndex) {
    var tmp;
    if (get_hexLength(_this__u8e3s4) > 4) {
      var i = charSequenceGet(_this__u8e3s4, 0) === _Char___init__impl__6a9atx(35) ? imul(startIndex, 2) + 1 | 0 : imul(startIndex, 2);
      tmp = toInt(slice(_this__u8e3s4, numberRangeToNumber(i, i + 1 | 0)), 16);
    } else {
      var i_0 = charSequenceGet(_this__u8e3s4, 0) === _Char___init__impl__6a9atx(35) ? startIndex + 1 | 0 : startIndex;
      // Inline function 'kotlin.let' call
      // Inline function 'kotlin.contracts.contract' call
      // Inline function 'com.github.ajalt.colormath.model.parseHex.<anonymous>' call
      var it = charSequenceGet(_this__u8e3s4, i_0);
      var tmp$ret$1 = toString_0(it) + toString_0(it);
      tmp = toInt(tmp$ret$1, 16);
    }
    return tmp;
  }
  function validateHex(_this__u8e3s4) {
    // Inline function 'kotlin.apply' call
    // Inline function 'kotlin.contracts.contract' call
    // Inline function 'com.github.ajalt.colormath.model.validateHex.<anonymous>' call
    // Inline function 'kotlin.require' call
    // Inline function 'kotlin.let' call
    // Inline function 'kotlin.contracts.contract' call
    // Inline function 'com.github.ajalt.colormath.model.validateHex.<anonymous>.<anonymous>' call
    var it = get_hexLength(_this__u8e3s4);
    switch (it) {
      case 3:
      case 4:
      case 6:
        var tmp$ret$0 = true;
        break;
      default:
        tmp$ret$0 = it === 8;
        break;
    }
    // Inline function 'kotlin.contracts.contract' call
    if (!tmp$ret$0) {
      // Inline function 'com.github.ajalt.colormath.model.validateHex.<anonymous>.<anonymous>' call
      var message = 'Hex string must be in the format "#ffffff" or "ffffff"';
      throw IllegalArgumentException_init_$Create$(toString(message));
    }
    return _this__u8e3s4;
  }
  function get_hexLength(_this__u8e3s4) {
    return startsWith(_this__u8e3s4, '#') ? _this__u8e3s4.length - 1 | 0 : _this__u8e3s4.length;
  }
  function get_SRGB_R() {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return SRGB_R;
  }
  var SRGB_R;
  function get_SRGB_G() {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return SRGB_G;
  }
  var SRGB_G;
  function get_SRGB_B() {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return SRGB_B;
  }
  var SRGB_B;
  function get_ACES_WHITE_POINT() {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return ACES_WHITE_POINT;
  }
  var ACES_WHITE_POINT;
  function get_ACES_AP0_R() {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return ACES_AP0_R;
  }
  var ACES_AP0_R;
  function get_ACES_AP0_G() {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return ACES_AP0_G;
  }
  var ACES_AP0_G;
  function get_ACES_AP0_B() {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return ACES_AP0_B;
  }
  var ACES_AP0_B;
  function get_ACES_AP1_R() {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return ACES_AP1_R;
  }
  var ACES_AP1_R;
  function get_ACES_AP1_G() {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return ACES_AP1_G;
  }
  var ACES_AP1_G;
  function get_ACES_AP1_B() {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return ACES_AP1_B;
  }
  var ACES_AP1_B;
  function RGBColorSpaces$SRGB$lambda($this$$receiver, it) {
    return it.l1c();
  }
  function RGBColorSpaces$BT2020$lambda($this$$receiver, color) {
    var tmp;
    if (color instanceof RGB) {
      tmp = color.k1f($this$$receiver);
    } else {
      if (color instanceof ICtCp) {
        tmp = color.b1e();
      } else {
        tmp = color.m1c().q1f($this$$receiver);
      }
    }
    return tmp;
  }
  function RGBColorSpaces() {
    RGBColorSpaces_instance = this;
    var tmp = this;
    var tmp_0 = Illuminant_getInstance().d1d_1;
    var tmp_1 = SRGBTransferFunctions_instance;
    var tmp_2 = get_SRGB_R();
    var tmp_3 = get_SRGB_G();
    var tmp_4 = get_SRGB_B();
    tmp.c1e_1 = new RGBColorSpaceImpl('sRGB', tmp_0, tmp_1, tmp_2, tmp_3, tmp_4, RGBColorSpaces$SRGB$lambda);
    this.d1e_1 = RGBColorSpace_0('Linear sRGB', Illuminant_getInstance().d1d_1, LinearTransferFunctions_instance, get_SRGB_R(), get_SRGB_G(), get_SRGB_B());
    this.e1e_1 = RGBColorSpace_0('ACES2065-1', get_ACES_WHITE_POINT(), LinearTransferFunctions_instance, get_ACES_AP0_R(), get_ACES_AP0_G(), get_ACES_AP0_B());
    this.f1e_1 = RGBColorSpace_0('ACEScc', get_ACES_WHITE_POINT(), ACESccTransferFunctions_getInstance(), get_ACES_AP1_R(), get_ACES_AP1_G(), get_ACES_AP1_B());
    this.g1e_1 = RGBColorSpace_0('ACEScct', get_ACES_WHITE_POINT(), ACEScctTransferFunctions_getInstance(), get_ACES_AP1_R(), get_ACES_AP1_G(), get_ACES_AP1_B());
    this.h1e_1 = RGBColorSpace_0('ACEScg', get_ACES_WHITE_POINT(), LinearTransferFunctions_instance, get_ACES_AP1_R(), get_ACES_AP1_G(), get_ACES_AP1_B());
    this.i1e_1 = RGBColorSpace_0('Adobe RGB', Illuminant_getInstance().d1d_1, new GammaTransferFunctions(2.19921875), xyY_init_$Create$(0.64, 0.33), xyY_init_$Create$(0.21, 0.71), xyY_init_$Create$(0.15, 0.06));
    var tmp_5 = this;
    var tmp_6 = Illuminant_getInstance().d1d_1;
    var tmp_7 = BT2020TransferFunctions_getInstance();
    var tmp_8 = xyY_init_$Create$(0.708, 0.292);
    var tmp_9 = xyY_init_$Create$(0.17, 0.797);
    var tmp_10 = xyY_init_$Create$(0.131, 0.046);
    tmp_5.j1e_1 = new RGBColorSpaceImpl('BT.2020', tmp_6, tmp_7, tmp_8, tmp_9, tmp_10, RGBColorSpaces$BT2020$lambda);
    this.k1e_1 = RGBColorSpace_0('BT.709', Illuminant_getInstance().d1d_1, BT709TransferFunctions_getInstance(), xyY_init_$Create$(0.64, 0.33), xyY_init_$Create$(0.3, 0.6), xyY_init_$Create$(0.15, 0.06));
    this.l1e_1 = RGBColorSpace_0('DCI P3', new WhitePoint('DCI P3', xyY_init_$Create$(0.314, 0.351)), new GammaTransferFunctions(2.6), xyY_init_$Create$(0.68, 0.32), xyY_init_$Create$(0.265, 0.69), xyY_init_$Create$(0.15, 0.06));
    this.m1e_1 = RGBColorSpace_0('Display P3', Illuminant_getInstance().d1d_1, SRGBTransferFunctions_instance, xyY_init_$Create$(0.68, 0.32), xyY_init_$Create$(0.265, 0.69), xyY_init_$Create$(0.15, 0.06));
    this.n1e_1 = RGBColorSpace_0('ROMM RGB', Illuminant_getInstance().b1d_1, ROMMTransferFunctions_instance, xyY_init_$Create$(0.7347, 0.2653), xyY_init_$Create$(0.1596, 0.8404), xyY_init_$Create$(0.0366, 1.0E-4));
  }
  var RGBColorSpaces_instance;
  function RGBColorSpaces_getInstance() {
    if (RGBColorSpaces_instance == null)
      new RGBColorSpaces();
    return RGBColorSpaces_instance;
  }
  function SRGB() {
    SRGB_instance = this;
    this.w1d_1 = RGBColorSpaces_getInstance().c1e_1;
  }
  protoOf(SRGB).h1d = function () {
    return this.w1d_1.h1d();
  };
  protoOf(SRGB).e1f = function () {
    return this.w1d_1.e1f();
  };
  protoOf(SRGB).d1f = function () {
    return this.w1d_1.d1f();
  };
  protoOf(SRGB).a12 = function () {
    return this.w1d_1.a12();
  };
  protoOf(SRGB).o1e = function () {
    return this.w1d_1.o1e();
  };
  protoOf(SRGB).f1f = function () {
    return this.w1d_1.f1f();
  };
  protoOf(SRGB).b1f = function (r, g, b, alpha) {
    return this.w1d_1.b1f(r, g, b, alpha);
  };
  protoOf(SRGB).v1d = function (r, g, b, alpha) {
    return this.w1d_1.v1d(r, g, b, alpha);
  };
  protoOf(SRGB).a1f = function (r, g, b, alpha) {
    return this.w1d_1.a1f(r, g, b, alpha);
  };
  protoOf(SRGB).c1f = function (hex) {
    return this.w1d_1.c1f(hex);
  };
  protoOf(SRGB).equals = function (other) {
    return equals(RGBColorSpaces_getInstance().c1e_1, other);
  };
  protoOf(SRGB).hashCode = function () {
    return hashCode(RGBColorSpaces_getInstance().c1e_1);
  };
  protoOf(SRGB).toString = function () {
    return 'sRGB';
  };
  var SRGB_instance;
  function SRGB_getInstance() {
    if (SRGB_instance == null)
      new SRGB();
    return SRGB_instance;
  }
  function RGBColorSpaceImpl(name, whitePoint, transferFunctions, r, g, b, convertImpl) {
    this.v1f_1 = name;
    this.w1f_1 = whitePoint;
    this.x1f_1 = transferFunctions;
    this.y1f_1 = r;
    this.z1f_1 = g;
    this.a1g_1 = b;
    this.b1g_1 = convertImpl;
    this.c1g_1 = zeroOneComponentInfo('RGB');
    this.d1g_1 = _Matrix___get_rowMajor__impl__vmgxkq(rgbToXyzMatrix(this.w1f_1, this.y1f_1, this.z1f_1, this.a1g_1));
    this.e1g_1 = _Matrix___get_rowMajor__impl__vmgxkq(inverse(_Matrix___init__impl__q3kp4w(this.d1g_1)));
  }
  protoOf(RGBColorSpaceImpl).a12 = function () {
    return this.v1f_1;
  };
  protoOf(RGBColorSpaceImpl).f1f = function () {
    return this.w1f_1;
  };
  protoOf(RGBColorSpaceImpl).o1e = function () {
    return this.x1f_1;
  };
  protoOf(RGBColorSpaceImpl).h1d = function () {
    return this.c1g_1;
  };
  protoOf(RGBColorSpaceImpl).d1f = function () {
    return this.d1g_1;
  };
  protoOf(RGBColorSpaceImpl).e1f = function () {
    return this.e1g_1;
  };
  protoOf(RGBColorSpaceImpl).toString = function () {
    return this.v1f_1;
  };
  protoOf(RGBColorSpaceImpl).v1d = function (r, g, b, alpha) {
    return new RGB(r, g, b, alpha, this);
  };
  protoOf(RGBColorSpaceImpl).equals = function (other) {
    if (this === other)
      return true;
    if (!(!(other == null) ? isInterface(other, RGBColorSpace) : false))
      return false;
    if (!(this.v1f_1 === other.a12()))
      return false;
    if (!this.w1f_1.equals(other.f1f()))
      return false;
    if (!equals(this.x1f_1, other.o1e()))
      return false;
    if (other instanceof RGBColorSpaceImpl) {
      if (!this.y1f_1.equals(other.y1f_1))
        return false;
      if (!this.z1f_1.equals(other.z1f_1))
        return false;
      if (!this.a1g_1.equals(other.a1g_1))
        return false;
    } else {
      if (!contentEquals(this.d1g_1, other.d1f()))
        return false;
      if (!contentEquals(this.e1g_1, other.e1f()))
        return false;
    }
    return true;
  };
  protoOf(RGBColorSpaceImpl).hashCode = function () {
    var result = getStringHashCode(this.v1f_1);
    result = imul(31, result) + this.w1f_1.hashCode() | 0;
    result = imul(31, result) + hashCode(this.x1f_1) | 0;
    result = imul(31, result) + this.y1f_1.hashCode() | 0;
    result = imul(31, result) + this.z1f_1.hashCode() | 0;
    result = imul(31, result) + this.a1g_1.hashCode() | 0;
    return result;
  };
  function SRGBTransferFunctions() {
  }
  protoOf(SRGBTransferFunctions).y1e = function (x) {
    return x <= 0.0031308 ? x * 12.92 : 1.055 * spow(x, 0.4166666666666667) - 0.055;
  };
  protoOf(SRGBTransferFunctions).x1e = function (x) {
    return x <= 0.04045 ? x / 12.92 : spow_0((x + 0.055) / 1.055, 2.4);
  };
  var SRGBTransferFunctions_instance;
  function SRGBTransferFunctions_getInstance() {
    return SRGBTransferFunctions_instance;
  }
  function RGBColorSpace_0(name, whitePoint, transferFunctions, r, g, b) {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return new RGBColorSpaceImpl(name, whitePoint, transferFunctions, r, g, b, RGBColorSpace$lambda);
  }
  function ACESccTransferFunctions() {
    ACESccTransferFunctions_instance = this;
    this.f1g_1 = 3.0517578125E-5;
    this.g1g_1 = 1.52587890625E-5;
    this.h1g_1 = -0.3013698630136986;
    var tmp = this;
    // Inline function 'kotlin.math.log2' call
    tmp.i1g_1 = (log2(65504.0) + 9.72) / 17.52;
  }
  protoOf(ACESccTransferFunctions).x1e = function (x) {
    var tmp;
    if (x <= -0.3013698630136986) {
      tmp = (spow_0(2.0, x * 17.52 - 9.72) - 1.52587890625E-5) * 2.0;
    } else if (x < this.i1g_1) {
      // Inline function 'kotlin.math.pow' call
      var x_0 = x * 17.52 - 9.72;
      tmp = Math.pow(2.0, x_0);
    } else {
      tmp = 65504.0;
    }
    return tmp;
  };
  protoOf(ACESccTransferFunctions).y1e = function (x) {
    var tmp;
    if (x < 3.0517578125E-5) {
      // Inline function 'kotlin.math.log2' call
      var x_0 = 1.52587890625E-5 + coerceAtLeast_0(x, 0.0) / 2.0;
      tmp = (log2(x_0) + 9.72) / 17.52;
    } else {
      // Inline function 'kotlin.math.log2' call
      tmp = (log2(x) + 9.72) / 17.52;
    }
    return tmp;
  };
  var ACESccTransferFunctions_instance;
  function ACESccTransferFunctions_getInstance() {
    if (ACESccTransferFunctions_instance == null)
      new ACESccTransferFunctions();
    return ACESccTransferFunctions_instance;
  }
  function ACEScctTransferFunctions() {
    ACEScctTransferFunctions_instance = this;
    this.j1g_1 = 10.5402377416545;
    this.k1g_1 = 0.0729055341958355;
    var tmp = this;
    // Inline function 'kotlin.math.log2' call
    tmp.l1g_1 = (log2(65504.0) + 9.72) / 17.52;
  }
  protoOf(ACEScctTransferFunctions).x1e = function (x) {
    var tmp;
    if (x <= 0.155251141552511) {
      tmp = (x - 0.0729055341958355) / 10.5402377416545;
    } else if (x < this.l1g_1) {
      // Inline function 'kotlin.math.pow' call
      var x_0 = x * 17.52 - 9.72;
      tmp = Math.pow(2.0, x_0);
    } else {
      tmp = 65504.0;
    }
    return tmp;
  };
  protoOf(ACEScctTransferFunctions).y1e = function (x) {
    var tmp;
    if (x < 0.0078125) {
      tmp = 10.5402377416545 * x + 0.0729055341958355;
    } else {
      // Inline function 'kotlin.math.log2' call
      tmp = (log2(x) + 9.72) / 17.52;
    }
    return tmp;
  };
  var ACEScctTransferFunctions_instance;
  function ACEScctTransferFunctions_getInstance() {
    if (ACEScctTransferFunctions_instance == null)
      new ACEScctTransferFunctions();
    return ACEScctTransferFunctions_instance;
  }
  function BT2020TransferFunctions() {
    BT2020TransferFunctions_instance = this;
    this.m1g_1 = 1.0993;
    this.n1g_1 = 0.0181;
    var tmp = this;
    // Inline function 'kotlin.math.pow' call
    tmp.o1g_1 = 1.0993 * Math.pow(0.0181, 0.45) - 0.09929999999999994;
  }
  protoOf(BT2020TransferFunctions).x1e = function (x) {
    return numberToDouble(x < this.o1g_1 ? x / 4.5 : spow_0((x + 0.09929999999999994) / 1.0993, 2.2222222222222223));
  };
  protoOf(BT2020TransferFunctions).y1e = function (x) {
    return x < 0.0181 ? 4.5 * x : 1.0993 * spow(x, 0.45) - 0.09929999999999994;
  };
  var BT2020TransferFunctions_instance;
  function BT2020TransferFunctions_getInstance() {
    if (BT2020TransferFunctions_instance == null)
      new BT2020TransferFunctions();
    return BT2020TransferFunctions_instance;
  }
  function BT709TransferFunctions() {
    BT709TransferFunctions_instance = this;
    this.p1g_1 = 1.099 * spow_0(0.018, 0.45) - 0.099;
  }
  protoOf(BT709TransferFunctions).x1e = function (x) {
    return numberToDouble(x < this.p1g_1 ? x / 4.5 : spow_0((x + 0.099) / 1.099, 2.2222222222222223));
  };
  protoOf(BT709TransferFunctions).y1e = function (x) {
    return x < 0.018 ? 4.5 * x : 1.099 * spow(x, 0.45) - 0.099;
  };
  var BT709TransferFunctions_instance;
  function BT709TransferFunctions_getInstance() {
    if (BT709TransferFunctions_instance == null)
      new BT709TransferFunctions();
    return BT709TransferFunctions_instance;
  }
  function ROMMTransferFunctions() {
    this.q1g_1 = 0.001953;
  }
  protoOf(ROMMTransferFunctions).x1e = function (x) {
    return x < 0.031248 ? x / 16.0 : spow(x, 1.8);
  };
  protoOf(ROMMTransferFunctions).y1e = function (x) {
    return x < 0.001953 ? x * 16.0 : spow(x, 0.5555555555555556);
  };
  var ROMMTransferFunctions_instance;
  function ROMMTransferFunctions_getInstance() {
    return ROMMTransferFunctions_instance;
  }
  function rgbToXyzMatrix(whitePoint, r, g, b) {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    var primaries = _Matrix___init__impl__q3kp4w_0(r.r1g_1, g.r1g_1, b.r1g_1, r.s1g_1, g.s1g_1, b.s1g_1, r.u1g(), g.u1g(), b.u1g());
    var wp = whitePoint.x1c_1;
    // Inline function 'com.github.ajalt.colormath.internal.dot' call
    var this_0 = inverse(primaries);
    var v0 = wp.v1g();
    var v1 = wp.t1g_1;
    var v2 = wp.w1g();
    // Inline function 'com.github.ajalt.colormath.model.rgbToXyzMatrix.<anonymous>' call
    var x = Matrix__get_impl_xogbpk(this_0, 0, 0) * v0 + Matrix__get_impl_xogbpk(this_0, 1, 0) * v1 + Matrix__get_impl_xogbpk(this_0, 2, 0) * v2;
    var y = Matrix__get_impl_xogbpk(this_0, 0, 1) * v0 + Matrix__get_impl_xogbpk(this_0, 1, 1) * v1 + Matrix__get_impl_xogbpk(this_0, 2, 1) * v2;
    var z = Matrix__get_impl_xogbpk(this_0, 0, 2) * v0 + Matrix__get_impl_xogbpk(this_0, 1, 2) * v1 + Matrix__get_impl_xogbpk(this_0, 2, 2) * v2;
    return dotDiagonal(primaries, x, y, z);
  }
  function RGBColorSpace$lambda($this$$receiver, color) {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    var tmp;
    if (color instanceof RGB) {
      tmp = color.k1f($this$$receiver);
    } else {
      tmp = color.m1c().q1f($this$$receiver);
    }
    return tmp;
  }
  var properties_initialized_RGBColorSpaces_kt_fsnpad;
  function _init_properties_RGBColorSpaces_kt__nc9fsz() {
    if (!properties_initialized_RGBColorSpaces_kt_fsnpad) {
      properties_initialized_RGBColorSpaces_kt_fsnpad = true;
      SRGB_R = xyY_init_$Create$(0.64, 0.33);
      SRGB_G = xyY_init_$Create$(0.3, 0.6);
      SRGB_B = xyY_init_$Create$(0.15, 0.06);
      ACES_WHITE_POINT = new WhitePoint('ACES', xyY_init_$Create$(0.32168, 0.33767));
      ACES_AP0_R = xyY_init_$Create$(0.7347, 0.2653);
      ACES_AP0_G = xyY_init_$Create$(0.0, 1.0);
      ACES_AP0_B = xyY_init_$Create$(1.0E-4, -0.077);
      ACES_AP1_R = xyY_init_$Create$(0.713, 0.293);
      ACES_AP1_G = xyY_init_$Create$(0.165, 0.83);
      ACES_AP1_B = xyY_init_$Create$(0.128, 0.044);
    }
  }
  function Companion_3() {
    Companion_instance_3 = this;
    this.x1g_1 = XYZColorSpaces_getInstance().y1g_1;
  }
  protoOf(Companion_3).h1d = function () {
    return this.x1g_1.h1d();
  };
  protoOf(Companion_3).f1f = function () {
    return this.x1g_1.f1f();
  };
  protoOf(Companion_3).v1d = function (x, y, z, alpha) {
    return this.x1g_1.v1d(x, y, z, alpha);
  };
  protoOf(Companion_3).hashCode = function () {
    return hashCode(XYZColorSpaces_getInstance().y1g_1);
  };
  protoOf(Companion_3).equals = function (other) {
    return equals(XYZColorSpaces_getInstance().y1g_1, other);
  };
  var Companion_instance_3;
  function Companion_getInstance_3() {
    if (Companion_instance_3 == null)
      new Companion_3();
    return Companion_instance_3;
  }
  function adaptToM($this, space, m, mi) {
    if (space.f1f().equals($this.p1f_1.f1f()))
      return $this;
    var transform = chromaticAdaptationMatrix(space, $this.p1f_1.f1f().x1c_1, m, mi);
    // Inline function 'com.github.ajalt.colormath.internal.dot' call
    var v0 = $this.l1f_1;
    var v1 = $this.m1f_1;
    var v2 = $this.n1f_1;
    // Inline function 'com.github.ajalt.colormath.model.XYZ.adaptToM.<anonymous>' call
    var xx = Matrix__get_impl_xogbpk(transform, 0, 0) * v0 + Matrix__get_impl_xogbpk(transform, 1, 0) * v1 + Matrix__get_impl_xogbpk(transform, 2, 0) * v2;
    var yy = Matrix__get_impl_xogbpk(transform, 0, 1) * v0 + Matrix__get_impl_xogbpk(transform, 1, 1) * v1 + Matrix__get_impl_xogbpk(transform, 2, 1) * v2;
    var zz = Matrix__get_impl_xogbpk(transform, 0, 2) * v0 + Matrix__get_impl_xogbpk(transform, 1, 2) * v1 + Matrix__get_impl_xogbpk(transform, 2, 2) * v2;
    return space.v1d(xx, yy, zz, $this.o1f_1);
  }
  function XYZ(x, y, z, alpha, space) {
    Companion_getInstance_3();
    this.l1f_1 = x;
    this.m1f_1 = y;
    this.n1f_1 = z;
    this.o1f_1 = alpha;
    this.p1f_1 = space;
  }
  protoOf(XYZ).k1c = function () {
    return this.p1f_1;
  };
  protoOf(XYZ).a1h = function (space) {
    return adaptToM(this, space, get_CAT02_XYZ_TO_LMS(), get_CAT02_LMS_TO_XYZ());
  };
  protoOf(XYZ).q1f = function (space) {
    var tmp0_container = this.a1h(XYZColorSpace_0(space.f1f()));
    var x = tmp0_container.a6();
    var y = tmp0_container.b6();
    var z = tmp0_container.mf();
    var f = space.o1e();
    // Inline function 'com.github.ajalt.colormath.internal.dot' call
    var this_0 = _Matrix___init__impl__q3kp4w(space.e1f());
    // Inline function 'com.github.ajalt.colormath.model.XYZ.toRGB.<anonymous>' call
    var r = Matrix__get_impl_xogbpk(this_0, 0, 0) * x + Matrix__get_impl_xogbpk(this_0, 1, 0) * y + Matrix__get_impl_xogbpk(this_0, 2, 0) * z;
    var g = Matrix__get_impl_xogbpk(this_0, 0, 1) * x + Matrix__get_impl_xogbpk(this_0, 1, 1) * y + Matrix__get_impl_xogbpk(this_0, 2, 1) * z;
    var b = Matrix__get_impl_xogbpk(this_0, 0, 2) * x + Matrix__get_impl_xogbpk(this_0, 1, 2) * y + Matrix__get_impl_xogbpk(this_0, 2, 2) * z;
    return space.v1d(f.y1e(r), f.y1e(g), f.y1e(b), this.o1f_1);
  };
  protoOf(XYZ).l1c = function () {
    return this.q1f(RGBColorSpaces_getInstance().c1e_1);
  };
  protoOf(XYZ).m1c = function () {
    return this;
  };
  protoOf(XYZ).a6 = function () {
    return this.l1f_1;
  };
  protoOf(XYZ).b6 = function () {
    return this.m1f_1;
  };
  protoOf(XYZ).mf = function () {
    return this.n1f_1;
  };
  protoOf(XYZ).toString = function () {
    return 'XYZ(x=' + this.l1f_1 + ', y=' + this.m1f_1 + ', z=' + this.n1f_1 + ', alpha=' + this.o1f_1 + ', space=' + this.p1f_1 + ')';
  };
  protoOf(XYZ).hashCode = function () {
    var result = getNumberHashCode(this.l1f_1);
    result = imul(result, 31) + getNumberHashCode(this.m1f_1) | 0;
    result = imul(result, 31) + getNumberHashCode(this.n1f_1) | 0;
    result = imul(result, 31) + getNumberHashCode(this.o1f_1) | 0;
    result = imul(result, 31) + hashCode(this.p1f_1) | 0;
    return result;
  };
  protoOf(XYZ).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof XYZ))
      return false;
    var tmp0_other_with_cast = other instanceof XYZ ? other : THROW_CCE();
    if (!equals(this.l1f_1, tmp0_other_with_cast.l1f_1))
      return false;
    if (!equals(this.m1f_1, tmp0_other_with_cast.m1f_1))
      return false;
    if (!equals(this.n1f_1, tmp0_other_with_cast.n1f_1))
      return false;
    if (!equals(this.o1f_1, tmp0_other_with_cast.o1f_1))
      return false;
    if (!equals(this.p1f_1, tmp0_other_with_cast.p1f_1))
      return false;
    return true;
  };
  function XYZColorSpace() {
  }
  function XYZColorSpace_0(whitePoint) {
    return whitePoint.equals(Illuminant_getInstance().d1d_1) ? XYZColorSpaces_getInstance().y1g_1 : whitePoint.equals(Illuminant_getInstance().b1d_1) ? XYZColorSpaces_getInstance().z1g_1 : new XYZColorSpaceImpl(whitePoint);
  }
  function XYZColorSpaces() {
    XYZColorSpaces_instance = this;
    this.y1g_1 = new XYZColorSpaceImpl(Illuminant_getInstance().d1d_1);
    this.z1g_1 = new XYZColorSpaceImpl(Illuminant_getInstance().b1d_1);
  }
  var XYZColorSpaces_instance;
  function XYZColorSpaces_getInstance() {
    if (XYZColorSpaces_instance == null)
      new XYZColorSpaces();
    return XYZColorSpaces_instance;
  }
  function chromaticAdaptationMatrix(_this__u8e3s4, srcWp, xyzToLms, lmsToXyz) {
    xyzToLms = xyzToLms === VOID ? get_CAT02_XYZ_TO_LMS() : xyzToLms;
    lmsToXyz = lmsToXyz === VOID ? get_CAT02_LMS_TO_XYZ() : lmsToXyz;
    var dstWp = _this__u8e3s4.f1f().x1c_1;
    var src = dot_0(xyzToLms, srcWp.v1g(), srcWp.t1g_1, srcWp.w1g());
    var dst = dot_0(xyzToLms, dstWp.v1g(), dstWp.t1g_1, dstWp.w1g());
    return dot(dotDiagonal(lmsToXyz, _Vector___get_l__impl__envr1l(dst) / _Vector___get_l__impl__envr1l(src), _Vector___get_m__impl__e5qq0m(dst) / _Vector___get_m__impl__e5qq0m(src), _Vector___get_s__impl__pzuljk(dst) / _Vector___get_s__impl__pzuljk(src)), xyzToLms);
  }
  function XYZColorSpaceImpl(whitePoint) {
    this.b1h_1 = whitePoint;
    this.c1h_1 = zeroOneComponentInfo('XYZ');
  }
  protoOf(XYZColorSpaceImpl).f1f = function () {
    return this.b1h_1;
  };
  protoOf(XYZColorSpaceImpl).h1d = function () {
    return this.c1h_1;
  };
  protoOf(XYZColorSpaceImpl).toString = function () {
    return 'XYZColorSpace(' + this.b1h_1 + ')';
  };
  protoOf(XYZColorSpaceImpl).v1d = function (x, y, z, alpha) {
    return new XYZ(x, y, z, alpha, this);
  };
  protoOf(XYZColorSpaceImpl).hashCode = function () {
    return this.b1h_1.hashCode();
  };
  protoOf(XYZColorSpaceImpl).equals = function (other) {
    var tmp;
    if (!(other == null) ? isInterface(other, XYZColorSpace) : false) {
      tmp = this.b1h_1.equals(other.f1f());
    } else {
      tmp = false;
    }
    return tmp;
  };
  function xyY_init_$Init$(x, y, Y, $this) {
    Y = Y === VOID ? 1.0 : Y;
    xyY.call($this, numberToDouble(x), numberToDouble(y), numberToDouble(Y));
    return $this;
  }
  function xyY_init_$Create$(x, y, Y) {
    return xyY_init_$Init$(x, y, Y, objectCreate(protoOf(xyY)));
  }
  function xyY(x, y, Y) {
    Y = Y === VOID ? 1.0 : Y;
    this.r1g_1 = x;
    this.s1g_1 = y;
    this.t1g_1 = Y;
  }
  protoOf(xyY).u1g = function () {
    return 1 - this.r1g_1 - this.s1g_1;
  };
  protoOf(xyY).v1g = function () {
    return this.r1g_1 * this.t1g_1 / this.s1g_1;
  };
  protoOf(xyY).w1g = function () {
    return (1 - this.r1g_1 - this.s1g_1) * this.t1g_1 / this.s1g_1;
  };
  protoOf(xyY).toString = function () {
    return 'xyY(x=' + this.r1g_1 + ', y=' + this.s1g_1 + ', Y=' + this.t1g_1 + ')';
  };
  protoOf(xyY).hashCode = function () {
    var result = getNumberHashCode(this.r1g_1);
    result = imul(result, 31) + getNumberHashCode(this.s1g_1) | 0;
    result = imul(result, 31) + getNumberHashCode(this.t1g_1) | 0;
    return result;
  };
  protoOf(xyY).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof xyY))
      return false;
    var tmp0_other_with_cast = other instanceof xyY ? other : THROW_CCE();
    if (!equals(this.r1g_1, tmp0_other_with_cast.r1g_1))
      return false;
    if (!equals(this.s1g_1, tmp0_other_with_cast.s1g_1))
      return false;
    if (!equals(this.t1g_1, tmp0_other_with_cast.t1g_1))
      return false;
    return true;
  };
  //region block: post-declaration
  protoOf(Ansi16).m1c = toXYZ;
  protoOf(Ansi256).m1c = toXYZ;
  protoOf(HSV).m1c = toXYZ;
  protoOf(Companion_2).k1d = from255$default;
  protoOf(Companion_2).j1d = invoke$default;
  protoOf(Companion_2).o1d = invoke$default_0;
  protoOf(SRGB).k1d = from255$default;
  protoOf(SRGB).j1d = invoke$default;
  protoOf(SRGB).o1d = invoke$default_0;
  protoOf(RGBColorSpaceImpl).j1d = invoke$default;
  protoOf(RGBColorSpaceImpl).a1f = invoke;
  protoOf(RGBColorSpaceImpl).o1d = invoke$default_0;
  protoOf(RGBColorSpaceImpl).c1f = invoke_0;
  protoOf(RGBColorSpaceImpl).b1f = from255;
  protoOf(RGBColorSpaceImpl).k1d = from255$default;
  //endregion
  //region block: init
  PqNonlinearity_instance = new PqNonlinearity();
  LinearTransferFunctions_instance = new LinearTransferFunctions();
  SRGBTransferFunctions_instance = new SRGBTransferFunctions();
  ROMMTransferFunctions_instance = new ROMMTransferFunctions();
  //endregion
  //region block: exports
  _.$_$ = _.$_$ || {};
  _.$_$.a = Ansi16;
  _.$_$.b = Ansi256;
  _.$_$.c = Companion_getInstance_2;
  //endregion
  return _;
}(module.exports, require('./kotlin-kotlin-stdlib.js')));

//# sourceMappingURL=colormath-root-colormath.js.map
