(function (_, kotlin_kotlin, kotlin_org_jetbrains_kotlinx_kotlinx_datetime) {
  'use strict';
  //region block: imports
  var imul = Math.imul;
  var protoOf = kotlin_kotlin.$_$.y8;
  var getStringHashCode = kotlin_kotlin.$_$.b8;
  var hashCode = kotlin_kotlin.$_$.c8;
  var THROW_CCE = kotlin_kotlin.$_$.jc;
  var equals = kotlin_kotlin.$_$.w7;
  var classMeta = kotlin_kotlin.$_$.u7;
  var setMetadataFor = kotlin_kotlin.$_$.z8;
  var split = kotlin_kotlin.$_$.hb;
  var ArrayList_init_$Create$ = kotlin_kotlin.$_$.m;
  var charSequenceLength = kotlin_kotlin.$_$.s7;
  var Unit_instance = kotlin_kotlin.$_$.l3;
  var collectionSizeOrDefault = kotlin_kotlin.$_$.i4;
  var ArrayList_init_$Create$_0 = kotlin_kotlin.$_$.l;
  var Companion_getInstance = kotlin_org_jetbrains_kotlinx_kotlinx_datetime.$_$.b;
  var joinToString = kotlin_kotlin.$_$.h5;
  var listOf = kotlin_kotlin.$_$.t5;
  var isCharSequence = kotlin_kotlin.$_$.i8;
  var trim = kotlin_kotlin.$_$.ub;
  var toString = kotlin_kotlin.$_$.b9;
  var reversed = kotlin_kotlin.$_$.g6;
  var last = kotlin_kotlin.$_$.q5;
  var emptyList = kotlin_kotlin.$_$.u4;
  var listOf_0 = kotlin_kotlin.$_$.s5;
  var plus = kotlin_kotlin.$_$.c6;
  var VOID = kotlin_kotlin.$_$.g;
  var first = kotlin_kotlin.$_$.z4;
  var copyToArray = kotlin_kotlin.$_$.q4;
  var to = kotlin_kotlin.$_$.ed;
  var json = kotlin_kotlin.$_$.q8;
  //endregion
  //region block: pre-declaration
  setMetadataFor(CommitRef, 'CommitRef', classMeta);
  setMetadataFor(GitAdapter, 'GitAdapter', classMeta);
  setMetadataFor(TagRef, 'TagRef', classMeta);
  //endregion
  function CommitRef(id, authorEmail, committerEmail, dateTime, parents, fullMessage) {
    this.i17_1 = id;
    this.j17_1 = authorEmail;
    this.k17_1 = committerEmail;
    this.l17_1 = dateTime;
    this.m17_1 = parents;
    this.n17_1 = fullMessage;
  }
  protoOf(CommitRef).toString = function () {
    return 'CommitRef(id=' + this.i17_1 + ', authorEmail=' + this.j17_1 + ', committerEmail=' + this.k17_1 + ', dateTime=' + this.l17_1 + ', parents=' + this.m17_1 + ', fullMessage=' + this.n17_1 + ')';
  };
  protoOf(CommitRef).hashCode = function () {
    var result = getStringHashCode(this.i17_1);
    result = imul(result, 31) + getStringHashCode(this.j17_1) | 0;
    result = imul(result, 31) + getStringHashCode(this.k17_1) | 0;
    result = imul(result, 31) + this.l17_1.hashCode() | 0;
    result = imul(result, 31) + hashCode(this.m17_1) | 0;
    result = imul(result, 31) + getStringHashCode(this.n17_1) | 0;
    return result;
  };
  protoOf(CommitRef).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof CommitRef))
      return false;
    var tmp0_other_with_cast = other instanceof CommitRef ? other : THROW_CCE();
    if (!(this.i17_1 === tmp0_other_with_cast.i17_1))
      return false;
    if (!(this.j17_1 === tmp0_other_with_cast.j17_1))
      return false;
    if (!(this.k17_1 === tmp0_other_with_cast.k17_1))
      return false;
    if (!this.l17_1.equals(tmp0_other_with_cast.l17_1))
      return false;
    if (!equals(this.m17_1, tmp0_other_with_cast.m17_1))
      return false;
    if (!(this.n17_1 === tmp0_other_with_cast.n17_1))
      return false;
    return true;
  };
  function parseLog($this, outputText) {
    // Inline function 'kotlin.collections.map' call
    // Inline function 'kotlin.collections.filter' call
    // Inline function 'kotlin.collections.filterTo' call
    var this_0 = split(outputText, [$this.p17_1 + '\n']);
    var destination = ArrayList_init_$Create$();
    var tmp0_iterator = this_0.r();
    while (tmp0_iterator.s()) {
      var element = tmp0_iterator.u();
      // Inline function 'com.zegreatrob.tools.wrapper.git.GitAdapter.parseLog.<anonymous>' call
      // Inline function 'kotlin.text.isNotEmpty' call
      if (charSequenceLength(element) > 0) {
        destination.o(element);
      }
    }
    // Inline function 'kotlin.collections.mapTo' call
    var destination_0 = ArrayList_init_$Create$_0(collectionSizeOrDefault(destination, 10));
    var tmp0_iterator_0 = destination.r();
    while (tmp0_iterator_0.s()) {
      var item = tmp0_iterator_0.u();
      // Inline function 'com.zegreatrob.tools.wrapper.git.GitAdapter.parseLog.<anonymous>' call
      var elements = split(item, ['\n']);
      var tmp = elements.c1(0);
      var tmp_0 = elements.c1(1);
      var tmp_1 = elements.c1(2);
      var tmp_2 = Companion_getInstance().l16(elements.c1(3));
      // Inline function 'kotlin.collections.filter' call
      // Inline function 'kotlin.collections.filterTo' call
      var this_1 = split(elements.c1(4), [' ']);
      var destination_1 = ArrayList_init_$Create$();
      var tmp0_iterator_1 = this_1.r();
      while (tmp0_iterator_1.s()) {
        var element_0 = tmp0_iterator_1.u();
        // Inline function 'com.zegreatrob.tools.wrapper.git.GitAdapter.parseLog.<anonymous>.<anonymous>' call
        // Inline function 'kotlin.text.isNotEmpty' call
        if (charSequenceLength(element_0) > 0) {
          destination_1.o(element_0);
        }
      }
      var tmp$ret$8 = new CommitRef(tmp, tmp_0, tmp_1, tmp_2, destination_1, joinToString(elements.z1(5, elements.l()), '\n'));
      destination_0.o(tmp$ret$8);
    }
    return destination_0;
  }
  function GitAdapter(workingDirectory) {
    this.o17_1 = workingDirectory;
    this.p17_1 = '--------!--------';
    this.q17_1 = '%H%n%ae%n%ce%n%aI%n%P%n%B%n' + this.p17_1;
  }
  protoOf(GitAdapter).r17 = function () {
    // Inline function 'kotlin.text.trim' call
    var this_0 = runProcess(listOf(['git', '--no-pager', 'rev-parse', 'HEAD']), this.o17_1);
    return toString(trim(isCharSequence(this_0) ? this_0 : THROW_CCE()));
  };
  protoOf(GitAdapter).s17 = function () {
    var outputText = runProcess(listOf(['git', '--no-pager', 'tag', '--list', '--sort=-taggerdate', '--format=%(refname:strip=2),%(*objectname),%(creatordate:iso-strict)']), this.o17_1);
    // Inline function 'kotlin.collections.mapNotNull' call
    // Inline function 'kotlin.collections.mapNotNullTo' call
    var this_0 = split(outputText, ['\n']);
    var destination = ArrayList_init_$Create$();
    // Inline function 'kotlin.collections.forEach' call
    var tmp0_iterator = this_0.r();
    while (tmp0_iterator.s()) {
      var element = tmp0_iterator.u();
      // Inline function 'kotlin.collections.mapNotNullTo.<anonymous>' call
      // Inline function 'com.zegreatrob.tools.wrapper.git.GitAdapter.listTags.<anonymous>' call
      var commaSplit = split(element, [',']);
      var tmp;
      if (commaSplit.l() >= 3) {
        tmp = new TagRef(joinToString(commaSplit.z1(0, commaSplit.l() - 2 | 0), ''), reversed(commaSplit).c1(1), Companion_getInstance().l16(last(commaSplit)));
      } else {
        tmp = null;
      }
      var tmp0_safe_receiver = tmp;
      if (tmp0_safe_receiver == null)
        null;
      else {
        // Inline function 'kotlin.let' call
        // Inline function 'kotlin.contracts.contract' call
        destination.o(tmp0_safe_receiver);
      }
    }
    var output = destination;
    return output;
  };
  protoOf(GitAdapter).t17 = function () {
    return parseLog(this, runProcess(listOf(['git', '--no-pager', 'log', '--format=' + this.q17_1]), this.o17_1));
  };
  protoOf(GitAdapter).u17 = function (begin, end) {
    return parseLog(this, runProcess(plus(listOf(['git', '--no-pager', 'log', '--format=' + this.q17_1, begin]), !(end == null) ? listOf_0(end) : emptyList()), this.o17_1));
  };
  protoOf(GitAdapter).v17 = function (begin, end, $super) {
    end = end === VOID ? null : end;
    return $super === VOID ? this.u17(begin, end) : $super.u17.call(this, begin, end);
  };
  function TagRef(name, commitId, dateTime) {
    this.w17_1 = name;
    this.x17_1 = commitId;
    this.y17_1 = dateTime;
  }
  protoOf(TagRef).toString = function () {
    return 'TagRef(name=' + this.w17_1 + ', commitId=' + this.x17_1 + ', dateTime=' + this.y17_1 + ')';
  };
  protoOf(TagRef).hashCode = function () {
    var result = getStringHashCode(this.w17_1);
    result = imul(result, 31) + getStringHashCode(this.x17_1) | 0;
    result = imul(result, 31) + this.y17_1.hashCode() | 0;
    return result;
  };
  protoOf(TagRef).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof TagRef))
      return false;
    var tmp0_other_with_cast = other instanceof TagRef ? other : THROW_CCE();
    if (!(this.w17_1 === tmp0_other_with_cast.w17_1))
      return false;
    if (!(this.x17_1 === tmp0_other_with_cast.x17_1))
      return false;
    if (!this.y17_1.equals(tmp0_other_with_cast.y17_1))
      return false;
    return true;
  };
  function get_childProcess() {
    _init_properties_RunProcess_js_kt__6db8dd();
    return childProcess;
  }
  var childProcess;
  function runProcess(args, workingDirectory) {
    _init_properties_RunProcess_js_kt__6db8dd();
    var program = first(args);
    // Inline function 'kotlin.collections.toTypedArray' call
    var this_0 = args.z1(1, args.l());
    var tmp$ret$0 = copyToArray(this_0);
    var spawn = get_childProcess().spawnSync(program, tmp$ret$0, json([to('cwd', workingDirectory), to('maxBuffer', 10485760)]));
    // Inline function 'kotlin.js.unsafeCast' call
    var tmp0_safe_receiver = spawn.stdout;
    return tmp0_safe_receiver == null ? null : tmp0_safe_receiver.toString('utf8');
  }
  var properties_initialized_RunProcess_js_kt_yehn37;
  function _init_properties_RunProcess_js_kt__6db8dd() {
    if (!properties_initialized_RunProcess_js_kt_yehn37) {
      properties_initialized_RunProcess_js_kt_yehn37 = true;
      childProcess = require('node:child_process');
    }
  }
  //region block: exports
  _.$_$ = _.$_$ || {};
  _.$_$.a = GitAdapter;
  //endregion
  return _;
}(module.exports, require('./kotlin-kotlin-stdlib.js'), require('./Kotlin-DateTime-library-kotlinx-datetime.js')));

//# sourceMappingURL=tools-git-adapter.js.map
